package cz.muni.cv4cursoradapter;

import android.Manifest;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.provider.ContactsContract;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity {

	private static final int MY_PERMISSIONS_REQUEST_READ_CONTACTS = 200;

	TextView noPermissionLayout;
	LinearLayout content;

	ListView list;
	PeopleCursorAdapter adapter;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);

		noPermissionLayout = (TextView) findViewById(R.id.no_permission);
		noPermissionLayout.setOnClickListener(new View.OnClickListener() {
			@Override public void onClick(View v) {
				Intent i = new Intent(android.provider.Settings.ACTION_APPLICATION_DETAILS_SETTINGS);
				i.addCategory(Intent.CATEGORY_DEFAULT);
				i.setData(Uri.parse("package:" + getPackageName()));
				startActivity(i);
			}
		});
		content = (LinearLayout) findViewById(R.id.content);
		list = (ListView) findViewById(R.id.list);

		adapter = new PeopleCursorAdapter(this, null, 0);
		list.setAdapter(adapter);
	}

	@Override
	protected void onResume() {
		super.onResume();
		checkPermission();
	}

	private void checkPermission() {
		if (ContextCompat.checkSelfPermission(this, Manifest.permission.READ_CONTACTS) != PackageManager.PERMISSION_GRANTED) {

			// Should we show an explanation?
			if (ActivityCompat.shouldShowRequestPermissionRationale(this, Manifest.permission.READ_CONTACTS)) {
				showNoPermission();
			} else {
				// Show dialog request
				ActivityCompat.requestPermissions(this, new String[]{Manifest.permission.READ_CONTACTS}, MY_PERMISSIONS_REQUEST_READ_CONTACTS);
			}
		} else {
			showContent();
		}
	}

	private void showContent() {
		noPermissionLayout.setVisibility(View.GONE);
		content.setVisibility(View.VISIBLE);
		Cursor cursor = getContentResolver().query(ContactsContract.CommonDataKinds.Phone.CONTENT_URI, null, null, null, null);
		adapter.swapCursor(cursor);
	}

	private void showNoPermission() {
		noPermissionLayout.setVisibility(View.VISIBLE);
		content.setVisibility(View.GONE);
	}

	@Override
	public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
		switch (requestCode) {
			case MY_PERMISSIONS_REQUEST_READ_CONTACTS: {
				// If request is cancelled, the result arrays are empty.
				if (grantResults.length > 0 && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
					showContent();
				} else {
					showNoPermission();
				}
				return;
			}
		}
	}
}
